#include <stdio.h>

/* esta funcion calcula el valor del 
numero almacenado en a en base b, o 
determina que eso es imposible */

int numero(char a[], int b)
{
  int d, i = 0, n = 0;

  while (a[i]) {
    d = a[i] - '0';
    if (d >= b)
      return -1;
    n = b*n + d;
    i++;
  }
  return n;
}

int main(void)
{
  char a[65], b[65];
  int p, q, np[11], nq[11];

  scanf("%s%s", a, b);

/* np y nq almacenan los valores de a
y b escritos en las diferentes bases */

  for (p = 2; p <= 10; p++) {
    np[p] = numero(a, p);
    nq[p] = numero(b, p);
  }

/* primero brincamos los imposibles */

  for (p = 2; np[p] < 0; p++);
  for (q = 2; nq[q] < 0; q++);

/* luego buscamos los iguales recordando
que las listas np y nq son crecientes */

  while (np[p] != nq[q]) {
    if (np[p] < nq[q])
      p++;
    else q++;
  }
  printf("%d %d %d\n", np[p], p, q);
  return 0;
}
